diff --git a/src/grobot.c b/src/grobot.c
index 73e12a0..489e2f6 100644
--- a/src/grobot.c
+++ b/src/grobot.c
@@ -54,750 +69,734 @@ static gint cthings[] = { SPACE, FOOD, PRIZE, WALL, BADDIE, ROBOT };
 
 static guint g_robot_signals[LAST_SIGNAL] = { 0 };
 
-static void g_robot_dispose(GObject *object);
-static void g_robot_finalize(GObject *object);
-
-static void g_robot_set_property(GObject *object, guint prop_id,
-	const GValue *value, GParamSpec *pspec);
+struct _GRobotPrivate
+{
+  GRobot_stats stats;
 
-static void g_robot_get_property(GObject *object, guint prop_id,
-	GValue *value, GParamSpec * pspec);
+  Map *map;
+};
 
-static GObjectClass *parent_class = NULL;
+G_DEFINE_TYPE_WITH_CODE(GRobot, g_robot, G_TYPE_OBJECT, G_ADD_PRIVATE(GRobot))
 
 static gint what_thing(const gchar *th);
 
-static void g_robot_init(GRobot *robot)
-{
-	/* Nothing yet, need to do priv stuff */
-}
-
-static void g_robot_class_init(GRobotClass *klass)
-{
-	GObjectClass *gobject_class;
-
-	gobject_class = (GObjectClass *) klass;
-
-	parent_class = g_type_class_ref(G_TYPE_OBJECT);
-
-	gobject_class->dispose = g_robot_dispose;
-	gobject_class->finalize = g_robot_finalize;
-	gobject_class->set_property = g_robot_set_property;
-	gobject_class->get_property = g_robot_get_property;
-
-	g_object_class_install_property(G_OBJECT_CLASS(klass), ARG_POS_X,
-		g_param_spec_int("x",
-			"x",
-			"X co-ordinate of current Position of the Robot",
-			G_MININT, G_MAXINT, 0, G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
-
-	g_object_class_install_property(G_OBJECT_CLASS(klass), ARG_POS_Y,
-		g_param_spec_int("y",
-			"y",
-			"y co-ordinate of current Position of the Robot",
-			G_MININT, G_MAXINT, 0, G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
-
-	g_object_class_install_property(G_OBJECT_CLASS(klass), ARG_DIRECTION,
-		g_param_spec_int("direction",
-			"direction",
-			"current Direction of the Robot",
-			G_MININT, G_MAXINT, 0, G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
-
-	g_object_class_install_property(G_OBJECT_CLASS(klass), ARG_SCORE,
-		g_param_spec_long("score",
-			"Score",
-			"current Score of the Robot",
-			G_MINLONG, G_MAXLONG, 0,
-			G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
-
-	g_object_class_install_property(G_OBJECT_CLASS(klass), ARG_ENERGY,
-		g_param_spec_long("energy",
-			"Energy",
-			"current Energy-level of the Robot",
-			G_MINLONG, G_MAXLONG, 0,
-			G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
-
-	g_object_class_install_property(G_OBJECT_CLASS(klass), ARG_SHIELDS,
-		g_param_spec_long("shields",
-			"Shields",
-			"current Shield-level of the Robot",
-			G_MINLONG, G_MAXLONG, 0,
-			G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
-
-	g_object_class_install_property(G_OBJECT_CLASS(klass), ARG_UNITS,
-		g_param_spec_long("units",
-			"Units",
-			"Units walked by the Robot so far",
-			G_MINLONG, G_MAXLONG, 0,
-			G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
-
-	g_object_class_install_property(G_OBJECT_CLASS(klass), ARG_SHOTS,
-		g_param_spec_long("shots",
-			"Shots",
-			"Number of Shots fired by the Robot",
-			G_MINLONG, G_MAXLONG, 0,
-			G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
-
-	g_object_class_install_property(G_OBJECT_CLASS(klass),
-		ARG_USER_INTERFACE,
-		g_param_spec_object("user-interface",
-			"UserInterface",
-			"Reference to the UI object",
-			G_TYPE_OBJECT, G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
-
-	g_object_class_install_property(G_OBJECT_CLASS(klass), ARG_MAP,
-		g_param_spec_object("map",
-			"Map",
-			"Reference to the Game Map object",
-			G_TYPE_OBJECT, G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
-
-	g_robot_signals[DEATH] =
-		g_signal_new("death",
-		G_TYPE_FROM_CLASS(klass),
-		G_SIGNAL_RUN_LAST,
-		G_STRUCT_OFFSET(GRobotClass, death),
-		NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0, NULL);
-}
-
 static void
 g_robot_set_property(GObject *object, guint prop_id, const GValue *value,
 	GParamSpec *pspec)
 {
-	GRobot *robot;
-	GObject *obj;
-
-	/* it's not null if we got it, but it might not be ours */
-	g_return_if_fail(G_IS_ROBOT(object));
-
-	robot = G_ROBOT(object);
-
-	switch (prop_id)
+  GRobot *robot;
+  GObject *obj;
+
+  /* it's not null if we got it, but it might not be ours */
+  g_return_if_fail(G_IS_ROBOT(object));
+
+  robot = G_ROBOT(object);
+
+  switch (prop_id)
+    {
+    case ARG_SCORE:
+      robot->priv->stats.score = g_value_get_long(value);
+      break;
+    case ARG_ENERGY:
+      robot->priv->stats.energy = g_value_get_long(value);
+      break;
+    case ARG_SHIELDS:
+      robot->priv->stats.shields = g_value_get_long(value);
+      break;
+    case ARG_SHOTS:
+      robot->priv->stats.shots = g_value_get_long(value);
+      break;
+    case ARG_UNITS:
+      robot->priv->stats.units = g_value_get_long(value);
+      break;
+    case ARG_MAP:
+      if (robot->priv->map != NULL)
 	{
-	case ARG_POS_X:
-		robot->x = g_value_get_int(value);
-		break;
-	case ARG_POS_Y:
-		robot->y = g_value_get_int(value);
-		break;
-	case ARG_DIRECTION:
-		robot->dir = g_value_get_int(value);
-		break;
-	case ARG_SCORE:
-		robot->score = g_value_get_long(value);
-		break;
-	case ARG_ENERGY:
-		robot->energy = g_value_get_long(value);
-		break;
-	case ARG_SHIELDS:
-		robot->shields = g_value_get_long(value);
-		break;
-	case ARG_SHOTS:
-		robot->shots = g_value_get_long(value);
-		break;
-	case ARG_UNITS:
-		robot->units = g_value_get_long(value);
-		break;
-	case ARG_USER_INTERFACE:
-		if (robot->ui != NULL)
-		{
-			g_object_unref(robot->ui);
-		}
-
-		obj = g_value_get_object(value);
-		if (obj != NULL)
-		{
-			robot->ui = g_object_ref(obj);
-		}
-
-		else
-		{
-			robot->ui = NULL;
-		}
-		break;
-	case ARG_MAP:
-		if (robot->map != NULL)
-		{
-			g_object_unref(robot->map);
-		}
-
-		obj = g_value_get_object(value);
-		if (obj != NULL)
-		{
-			robot->map = g_object_ref(obj);
-		}
+	  g_object_unref(robot->priv->map);
+	}
 
-		else
-		{
-			robot->map = NULL;
-		}
-		break;
-	default:
-		G_OBJECT_WARN_INVALID_PROPERTY_ID(object, prop_id, pspec);
-		break;
+      obj = g_value_get_object(value);
+      if (obj != NULL)
+	{
+	  robot->priv->map = MAP(g_object_ref(obj));
+	}
+      else
+	{
+	  robot->priv->map = NULL;
 	}
+      break;
+    default:
+      G_OBJECT_WARN_INVALID_PROPERTY_ID(object, prop_id, pspec);
+      break;
+    }
 }
 
 static void
 g_robot_get_property(GObject *object, guint prop_id, GValue *value,
 	GParamSpec *pspec)
 {
-	GRobot *robot;
-
-	/* it's not null if we got it, but it might not be ours */
-	g_return_if_fail(G_IS_ROBOT(object));
-
-	robot = G_ROBOT(object);
-
-	switch (prop_id)
-	{
-	case ARG_POS_X:
-		g_value_set_int(value, robot->x);
-		break;
-	case ARG_POS_Y:
-		g_value_set_int(value, robot->y);
-		break;
-	case ARG_DIRECTION:
-		g_value_set_int(value, robot->dir);
-		break;
-	case ARG_SCORE:
-		g_value_set_long(value, robot->score);
-		break;
-	case ARG_ENERGY:
-		g_value_set_long(value, robot->energy);
-		break;
-	case ARG_SHIELDS:
-		g_value_set_long(value, robot->shields);
-		break;
-	case ARG_SHOTS:
-		g_value_set_long(value, robot->shots);
-		break;
-	case ARG_UNITS:
-		g_value_set_long(value, robot->units);
-		break;
-	case ARG_USER_INTERFACE:
-		g_value_set_object(value, g_object_ref(G_OBJECT(robot->ui)));
-		break;
-	case ARG_MAP:
-		g_value_set_object(value, g_object_ref(G_OBJECT(robot->map)));
-		break;
-	default:
-		G_OBJECT_WARN_INVALID_PROPERTY_ID(object, prop_id, pspec);
-		break;
-	}
+  GRobot *robot;
+
+  /* it's not null if we got it, but it might not be ours */
+  g_return_if_fail(G_IS_ROBOT(object));
+
+  robot = G_ROBOT(object);
+
+  switch (prop_id)
+    {
+    case ARG_SCORE:
+      g_value_set_long(value, robot->priv->stats.score);
+      break;
+    case ARG_ENERGY:
+      g_value_set_long(value, robot->priv->stats.energy);
+      break;
+    case ARG_SHIELDS:
+      g_value_set_long(value, robot->priv->stats.shields);
+      break;
+    case ARG_SHOTS:
+      g_value_set_long(value, robot->priv->stats.shots);
+      break;
+    case ARG_UNITS:
+      g_value_set_long(value, robot->priv->stats.units);
+      break;
+    case ARG_MAP:
+      g_value_set_object(value, g_object_ref(G_OBJECT(robot->priv->map)));
+      break;
+    default:
+      G_OBJECT_WARN_INVALID_PROPERTY_ID(object, prop_id, pspec);
+      break;
+    }
 }
 
-GRobot *g_robot_new(gint x, gint y, gint dir, glong score, glong energy,
-	glong shields, glong units, glong shots, UIArena *ui, Map *map)
+static void
+g_robot_dispose(GObject *object)
 {
+  if (G_ROBOT(object)->priv->map != NULL)
+    {
+      g_object_unref(G_OBJECT(G_ROBOT(object)->priv->map));
+    }
 
-	return G_ROBOT(g_object_new(g_robot_get_type(),
-			"x", x,
-			"y", y,
-			"direction", dir,
-			"score", score,
-			"energy", energy,
-			"shields", shields,
-			"units", units,
-			"shots", shots, "user_interface", ui, "map", map, NULL));
+  G_OBJECT_CLASS(g_robot_parent_class)->dispose(object);
 }
 
-static void g_robot_dispose(GObject *object)
+static void
+g_robot_finalize(GObject *object)
 {
-	GRobot *robot = G_ROBOT(object);
-
-	if (robot->ui != NULL)
-	{
-		g_object_unref(G_OBJECT(robot->ui));
-	}
-
-	if (robot->map != NULL)
-	{
-		g_object_unref(G_OBJECT(robot->map));
-	}
-
-	parent_class->dispose(object);
+  if (G_ROBOT(object)->priv->map != NULL)
+    {
+      g_object_unref(G_OBJECT(G_ROBOT(object)->priv->map));
+    }
+  G_OBJECT_CLASS(g_robot_parent_class)->finalize(object);
 }
 
-static void g_robot_finalize(GObject *object)
+static void
+g_robot_init(GRobot *self)
 {
-	parent_class->finalize(object);
+  self->priv = g_robot_get_instance_private(self);
 }
 
-void g_robot_turn(GRobot *robot, gint num_turns)
+static void
+g_robot_class_init(GRobotClass *klass)
 {
-	gint i;
-	gint incr;
-
-	/* turn left or right? */
-
-	incr = sign(num_turns);
-
-	for (i = 0; i < abs(num_turns); i++)
-	{
-		robot->dir += incr;
-
-		if (robot->dir > 3)
-		{
-			robot->dir = 0;
-		}
-
-		else if (robot->dir < 0)
-		{
-			robot->dir = 3;
-		}
-
-		/* animate the robot */
-		ui_arena_move_robot(robot->ui, robot->x, robot->y, robot->x,
-			robot->y, robot->dir, robot->energy,
-			robot->score, robot->shields);
-
-		robot->energy -= 2;
-
-		if (robot->energy < 1)
-		{
-			g_signal_emit(robot, g_robot_signals[DEATH], 0);
-		}
-	}							/* for */
+  GObjectClass *gobject_class;
+
+  gobject_class = (GObjectClass *) klass;
+
+  gobject_class->dispose = g_robot_dispose;
+  gobject_class->finalize = g_robot_finalize;
+  gobject_class->set_property = g_robot_set_property;
+  gobject_class->get_property = g_robot_get_property;
+
+  g_object_class_install_property
+    (G_OBJECT_CLASS(klass), ARG_SCORE,
+     g_param_spec_long("score",
+		       "Score",
+		       "current Score of the Robot",
+		       0, G_MAXLONG, 0,
+		       G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
+
+  g_object_class_install_property
+    (G_OBJECT_CLASS(klass), ARG_ENERGY,
+     g_param_spec_long("energy",
+		       "Energy",
+		       "current Energy-level of the Robot",
+		       G_MINLONG, G_MAXLONG, DEFAULT_ENERGY,
+		       G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
+
+  g_object_class_install_property
+    (G_OBJECT_CLASS(klass), ARG_SHIELDS,
+     g_param_spec_long("shields",
+		       "Shields",
+		       "current Shield-level of the Robot",
+		       G_MINLONG, G_MAXLONG, DEFAULT_SHIELDS,
+		       G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
+
+  g_object_class_install_property
+    (G_OBJECT_CLASS(klass), ARG_UNITS,
+     g_param_spec_long("units",
+		       "Units",
+		       "Units walked by the Robot so far",
+		       0, G_MAXLONG, 0,
+		       G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
+
+  g_object_class_install_property
+    (G_OBJECT_CLASS(klass), ARG_SHOTS,
+     g_param_spec_long("shots",
+		       "Shots",
+		       "Number of Shots fired by the Robot",
+		       0, G_MAXLONG, 0,
+		       G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
+
+  g_object_class_install_property
+    (G_OBJECT_CLASS(klass), ARG_MAP,
+     g_param_spec_object("map",
+			 "Map",
+			 "Reference to the Game Map object",
+			 G_TYPE_OBJECT, G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
+
+  g_robot_signals[DEATH] =
+    g_signal_new("death",
+		 G_TYPE_FROM_CLASS(klass),
+		 G_SIGNAL_RUN_LAST,
+		 G_STRUCT_OFFSET(GRobotClass, death),
+		 NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0, NULL);
+  g_robot_signals[STATS_UPDATE] =
+    g_signal_new("robot-stats-update",
+		 G_TYPE_ROBOT,
+		 G_SIGNAL_ACTION,
+		 0,
+		 NULL /* accumulator */,
+		 NULL /* accumulator data */,
+		 NULL /* C marshaller */,
+		 G_TYPE_NONE /* return_type */,
+		 1    /* n_params */,
+		 G_TYPE_POINTER  /* param_types */);
 }
 
-gboolean g_robot_move(GRobot *robot, gint steps)
+GRobot*
+g_robot_new(glong energy, glong shields, glong units, glong shots, Map *map)
 {
-	gint x_to, y_to;
-	gint dx = 0, dy = 0;
-	gint i;
-
-	g_return_val_if_fail(robot->ui != NULL && robot->map != NULL, FALSE);
-
-	/* determine changes to x,y */
-
-	switch (robot->dir)
-	{
-	case NORTH:				/* N */
-		dx = 0;
-		dy = -1 * sign(steps);
-		break;
-	case EAST:					/* E */
-		dx = sign(steps);
-		dy = 0;
-		break;
-	case SOUTH:				/* S */
-		dx = 0;
-		dy = sign(steps);
-		break;
-	case WEST:					/* W */
-		dx = -1 * sign(steps);
-		dy = 0;
-		break;
-	}
-
-	/* Move the robot */
-	/* Arguably this should use energy even if steps=0, but it doesn't... */
-
-	for (i = 0; i < abs(steps); i++)
-	{
-		/* check for a space */
-
-		x_to = robot->x + dx;
-		y_to = robot->y + dy;
-
-		/* no matter what, this took energy */
-
-		robot->energy -= 2;
-
-		switch (MAP_GET_OBJECT(robot->map, x_to, y_to))
-		{
-		case SPACE:
-			/* move the robot there */
-			MAP_SET_OBJECT(robot->map, robot->x, robot->y, SPACE);
-			MAP_SET_OBJECT(robot->map, x_to, y_to, ROBOT);
+  return G_ROBOT(g_object_new(g_robot_get_type(),
+			      "score", 0,
+			      "energy", energy,
+			      "shields", shields,
+			      "units", units,
+			      "shots", shots,
+			      "map", map, NULL));
+}
 
-			break;
+gboolean
+g_robot_is_alive(GRobot *self)
+{
+  g_return_val_if_fail(G_IS_ROBOT(self), FALSE);
 
-		case BADDIE:
-			/* Damage */
-			robot->shields -= 10;
+  return(self->priv->stats.energy > 0 && self->priv->stats.shields > 0);
+}
 
-			x_to = robot->x;
-			y_to = robot->y;
+glong
+g_robot_get_turn(GRobot *self)
+{
+  g_return_val_if_fail(G_IS_ROBOT(self), -999);
 
-			break;
+  return(self->priv->stats.turn);
+}
 
-		case WALL:
-			/* less damage */
-			robot->shields -= 2;
+glong
+g_robot_get_shields(GRobot *self)
+{
+  g_return_val_if_fail(G_IS_ROBOT(self), -999);
 
-			x_to = robot->x;
-			y_to = robot->y;
+  return(self->priv->stats.shields);
+}
 
-			break;
+glong
+g_robot_get_score(GRobot *self)
+{
+  g_return_val_if_fail(G_IS_ROBOT(self), -999);
 
-		default:
-			/* even less damage */
-			robot->shields -= 1;
+  return(self->priv->stats.score);
+}
 
-			x_to = robot->x;
-			y_to = robot->y;
+glong
+g_robot_get_shots(GRobot *self)
+{
+  g_return_val_if_fail(G_IS_ROBOT(self), -999);
 
-			break;
-		}
+  return(self->priv->stats.shots);
+}
 
-		/* Animate/update the robot/arena/status regardless of
-		   whether the movement-attempt succeeded:
-		*/
-		ui_arena_move_robot(robot->ui, robot->x, robot->y, x_to, y_to,
-			robot->dir, robot->energy, robot->score, robot->shields);
+glong
+g_robot_get_energy(GRobot *self)
+{
+  g_return_val_if_fail(G_IS_ROBOT(self), -999);
 
-		if (robot->energy < 1 || robot->shields < 1)
-		{
-			g_signal_emit(robot, g_robot_signals[DEATH], 0);
-		}
+  return(self->priv->stats.energy);
+}
 
-		if (x_to == robot->x && y_to == robot->y) {
-			/* NOTE: by returning here, we charge only 1 hit
-			   against energy and shields, regardless of
-			   how many spaces the robot was attempting to go....
-			*/
-			return FALSE;
-		}
+glong
+g_robot_get_move_energy_cost()
+{
+  return action_energy_cost[ACTION_MOVE];
+}
 
-		robot->x = x_to;
-		robot->y = y_to;
-		robot->units++;
-	}							/* for */
+glong
+g_robot_get_turn_energy_cost()
+{
+  return action_energy_cost[ACTION_TURN];
+}
 
-	return TRUE;
+glong
+g_robot_get_feel_energy_cost()
+{
+  return action_energy_cost[ACTION_FEEL];
 }
 
-gboolean g_robot_smell(GRobot *robot, gchar *str)
+glong
+g_robot_get_smell_energy_cost()
 {
-	gint th;
-	gint i, j;
+  return action_energy_cost[ACTION_SMELL];
+}
 
-	g_return_val_if_fail(robot->ui != NULL && robot->map != NULL, FALSE);
+glong
+g_robot_get_look_energy_cost()
+{
+  return action_energy_cost[ACTION_LOOK];
+}
 
-	th = what_thing(str);
+glong
+g_robot_get_grab_energy_cost()
+{
+  return action_energy_cost[ACTION_GRAB];
+}
 
-	/* no matter what, this took energy */
+glong
+g_robot_get_zap_energy_cost()
+{
+  return action_energy_cost[ACTION_ZAP];
+}
 
-	if (--robot->energy < 1)
+/** Function to perform updates to robot statistics and to emit a
+ * signal on every status update.
+ *
+ * It's important to always use this function to modify the robot's
+ * statistics because:
+ *
+ * 1. It ensures consistent signal emission.
+ * 2. It performs testing and emits the robot-death signal if appropriate.
+ * 3. It automatically increments turns.
+ *
+ * Call the function using the robot_stats enum along with the new
+ * value to set.  
+ *
+ * The arguments will always come in pairs.  The following will set
+ * energy to 900 and set score to 5:
+ *
+ *    g_robot_stats_update(robot, "robot-move", 4, ARG_ENERGY, 900, ARG_SCORE, 5);
+ *
+ * \note It is vital that num_args be correctly set.
+ *
+ * \param [in, out] self the robot to update.
+ * \param [in] status_message describing the change being made
+ *        (usually something like "robot-move" to indicate that the
+ *        robot being moved is the reason for the stats update).  It
+ *        is safe to free this after making this call.
+ * \param [in] num_args the number of arguments that follow.
+ * \param [in] ... pairs of robot_stats enum entries (e.g. ARG_SCORE,
+ * ARG_ENERGY) along with the values to set them to.
+ *
+ * \returns TRUE if it succeeds; FALSE otherwise.
+ */
+static gboolean
+g_robot_stats_update(GRobot *self,
+		     gchar *status_message,
+		     gint num_args,
+		     ...)
+{
+  g_return_val_if_fail(num_args % 2 == 0, FALSE);
+
+  /* Always update turn. */
+  self->priv->stats.turn = self->priv->stats.turn + 1;
+
+  GRobot_change *change;
+  change = g_malloc(sizeof(GRobot_change));
+  g_strlcpy(change->status_message, status_message, ROBOT_STATUS_MESSAGE_LEN);
+  memcpy(&(change->before_change), self->priv, sizeof(GRobot_stats));
+
+  va_list       intArgumentPointer;
+  va_start( intArgumentPointer, num_args );
+  gint arg_stat;
+  gint arg_value;
+  for(gint i = 0; i < (num_args / 2); i++ )
+    {
+      arg_stat = va_arg(intArgumentPointer, int);
+      arg_value = va_arg(intArgumentPointer, int);
+
+      switch (arg_stat)
 	{
-		g_signal_emit(robot, g_robot_signals[DEATH], 0);
+	case ARG_SCORE:
+	  self->priv->stats.score = arg_value;
+	  break;
+	case ARG_ENERGY:
+	  self->priv->stats.energy = arg_value;
+	  break;
+	case ARG_SHIELDS:
+	  self->priv->stats.shields = arg_value;
+	  break;
+	case ARG_SHOTS:
+	  self->priv->stats.shots = arg_value;
+	  break;
+	case ARG_UNITS:
+	  self->priv->stats.units = arg_value;
+	  break;
+	default:
+	  g_critical("g_robot_stats_update: Unknown stat type: %d; value: %d", arg_stat, arg_value);
 	}
+      arg_stat = 0;
+    }
 
-	ui_arena_robot_smell(robot->ui, robot->x, robot->y, robot->dir,
-		robot->energy, robot->score, robot->shields,
-		str);
-
-	/* Smell for the thing */
-
-	for (i = robot->x - 1; i <= robot->x + 1; i++)
-	{
-		for (j = robot->y - 1; j <= robot->y + 1; j++)
-		{
-			if (!(i == robot->x && j == robot->y)
-				&& MAP_GET_OBJECT(robot->map, i, j) == th)
-			{
-				/* Found it */
-				return TRUE;
-			}
-		}						/* for */
-	}							/* for */
+  va_end( intArgumentPointer );
+  memcpy(&(change->after_change), self->priv, sizeof(GRobot_stats));
+  g_signal_emit(self, g_robot_signals[STATS_UPDATE], 0, change);
 
-	/* Failed to find it */
+  if(!g_robot_is_alive(self))
+    g_signal_emit(self, g_robot_signals[DEATH], 0);
+  g_free(change);
 
-	return FALSE;
+  return TRUE;
 }
 
-gboolean g_robot_feel(GRobot *robot, gchar *str)
+gboolean
+g_robot_turn(GRobot *self, gint num_turns)
 {
-	gint th;
-	gint x_to, y_to;
-	gint dx = 0, dy = 0;
+  g_return_val_if_fail(G_IS_ROBOT(self), FALSE);
 
-	g_return_val_if_fail(robot->ui != NULL && robot->map != NULL, FALSE);
+  if(!g_robot_is_alive(self))
+    return FALSE;
 
-	th = what_thing(str);
+  if(num_turns == 0)
+    return TRUE;
 
-	/* determine changes to x,y */
-	switch (robot->dir)
-	{
-	case NORTH:				/* N */
-		dx = 0;
-		dy = -1;
-		break;
-	case EAST:					/* E */
-		dx = 1;
-		dy = 0;
-		break;
-	case SOUTH:				/* S */
-		dx = 0;
-		dy = 1;
-		break;
-	case WEST:					/* W */
-		dx = -1;
-		dy = 0;
-		break;
-	}
+  gint x, y, orientation;
 
-	/* no matter what, this took energy */
-	if (--robot->energy < 1)
-	{
-		g_signal_emit(robot, g_robot_signals[DEATH], 0);
-	}
-
-	/* Feel for the thing */
-	x_to = robot->x + dx;
-	y_to = robot->y + dy;
+  if(!map_find_thing(self->priv->map, self, &x, &y, &orientation))
+    {
+      g_warning("g_robot_turn: robot not found on map.");
+      return FALSE;
+    }
 
-	ui_arena_robot_feel(robot->ui, robot->x, robot->y, robot->dir, x_to,
-		y_to, robot->energy, robot->score, robot->shields, str);
+  gint turn = 1; /* Compute one turn so we can check energy each time. */
+  if(num_turns < 0)
+    turn = turn * -1;
 
-	if (MAP_GET_OBJECT(robot->map, x_to, y_to) == BADDIE)
-	{
-		/* touching a baddie is hurtful */
-		if (robot->shields < 1)
-		{
-			g_signal_emit(robot, g_robot_signals[DEATH], 0);
-		}
-	}
+  if(!map_thing_turn_clockwise(self->priv->map, x, y, turn))
+    return FALSE;
 
-	if (MAP_GET_OBJECT(robot->map, x_to, y_to) == th)
-	{
-		return TRUE;
-	}
+  g_robot_stats_update(self, "robot-turn", 2,
+		       ARG_ENERGY, self->priv->stats.energy - action_energy_cost[ACTION_TURN]);
 
-	/* Did not feel it */
-	return FALSE;
+  return(g_robot_turn(self, num_turns - turn));
 }
 
-gboolean g_robot_look(GRobot *robot, gchar *str)
+gboolean
+g_robot_move(GRobot *robot, gint steps)
 {
-	gint th;
-	gint x_to, y_to;
-	gint dx = 0, dy = 0;
-
-	g_return_val_if_fail(robot->ui != NULL && robot->map != NULL, FALSE);
-
-	th = what_thing(str);
-
-	/* determine changes to x,y */
-	switch (robot->dir)
-	{
-	case NORTH:
-		dx = 0;
-		dy = -1;
-		break;
-	case EAST:
-		dx = 1;
-		dy = 0;
-		break;
-	case SOUTH:
-		dx = 0;
-		dy = 1;
-		break;
-	case WEST:
-		dx = -1;
-		dy = 0;
-		break;
-	}
+  g_return_val_if_fail(G_IS_ROBOT(robot), FALSE);
+  g_return_val_if_fail(robot->priv->map != NULL, FALSE);
+
+  if(!g_robot_is_alive(robot))
+    return FALSE;
+  if(steps == 0)
+    return TRUE;
+
+  gboolean retval = FALSE;
+
+  /* determine changes to x,y */
+  gint x_to, y_to, x, y, orientation;
+  if(!map_find_thing(robot->priv->map, robot, &x, &y, &orientation))
+    {
+      g_warning("g_robot_move: robot not found on map.");
+      return FALSE;
+    }
+
+  if(steps < 0) // We're going backwards, so invert the orientation
+    orientation = map_compute_clockwise_turn(orientation, 2);
+  map_compute_facing_coords(x, y, orientation, &x_to, &y_to);
+
+  gint shields_delta = 0;
+
+  switch (map_get_loc_thing_char(robot->priv->map, x_to, y_to))
+    {
+    case SPACE:
+      /* move the robot there */
+      retval = map_move(robot->priv->map, x, y, x_to, y_to);
+      break;
+    case BADDIE:
+      /* Damage */
+      shields_delta = shields_delta - 10;
+      break;
+    case WALL:
+      /* less damage */
+      shields_delta = shields_delta - 2;
+      break;
+    default:
+      /* even less damage */
+      shields_delta = shields_delta - 1;
+      break;
+    }
+
+  g_robot_stats_update(robot, "robot-move", 6,
+		       ARG_ENERGY, robot->priv->stats.energy - action_energy_cost[ACTION_MOVE],
+		       ARG_SHIELDS, robot->priv->stats.shields + shields_delta,
+		       ARG_UNITS, robot->priv->stats.units + 1);
+
+  if(!retval) // Bail out if we failed
+    return(retval);
+
+  gint step_adj = 1;
+  if(steps < 0)
+    step_adj = step_adj * -1;
+
+  // take more steps
+  return(g_robot_move(robot, steps - step_adj));
+}
 
-	/* no matter what, this took energy */
-	if (--robot->energy < 1)
-	{
-		g_signal_emit(robot, g_robot_signals[DEATH], 0);
-	}
+gboolean
+g_robot_smell(GRobot *robot, gchar *str)
+{
+  g_return_val_if_fail(G_IS_ROBOT(robot), FALSE);
+  g_return_val_if_fail(robot->priv->map != NULL, FALSE);
 
-	/* Look for the thing */
-	x_to = robot->x + dx;
-	y_to = robot->y + dy;
+  if(!g_robot_is_alive(robot))
+    return FALSE;
 
-	ui_arena_robot_look(robot->ui, robot->x, robot->y, robot->dir, x_to,
-		y_to, robot->energy, robot->score, robot->shields, str);
+  gboolean retval = FALSE;
+  gint th;
+  gint i, j;
 
-	while (MAP_GET_OBJECT(robot->map, x_to, y_to) == SPACE)
-	{
-		/* move the focus */
-		x_to += dx;
-		y_to += dy;
-	}
+  th = what_thing(str);
+  /* Determine Robot x, y */
+  gint x, y;
+  map_find_thing(robot->priv->map, robot, &x, &y, NULL);
 
-	/* Outside the loop, we have found something */
-	if (MAP_GET_OBJECT(robot->map, x_to, y_to) == th)
+  /* Smell for the thing */
+  for (i = x - 1; i <= x + 1; i++)
+    {
+      for (j = y - 1; j <= y + 1; j++)
 	{
-		return TRUE;
-	}
-
-	/* else, we did not find it */
-	return FALSE;
+	  if (!(i == x && j == y)
+	      && map_get_loc_thing_char(robot->priv->map, i, j) == th)
+	    {
+	      /* Found it */
+	      retval = TRUE;
+	    }
+	} /* for j */
+    } /* for i */
+
+  g_robot_stats_update(robot, "robot-smell", 2,
+		       ARG_ENERGY, robot->priv->stats.energy - action_energy_cost[ACTION_SMELL]);
+
+  return retval;
 }
 
-gboolean g_robot_grab(GRobot *robot)
+gboolean
+g_robot_feel(GRobot *robot, gchar *str)
 {
-	gint x_to, y_to;
-	gint dx = 0, dy = 0;
-
-	g_return_val_if_fail(robot->ui != NULL && robot->map != NULL, FALSE);
-
-	/* determine changes to x,y */
-
-	switch (robot->dir)
-	{
-	case NORTH:				/* N */
-		dx = 0;
-		dy = -1;
-		break;
-	case EAST:					/* E */
-		dx = 1;
-		dy = 0;
-		break;
-	case SOUTH:				/* S */
-		dx = 0;
-		dy = 1;
-		break;
-	case WEST:					/* W */
-		dx = -1;
-		dy = 0;
-		break;
-	}
-
-	/* Try to grab the thing */
+  g_return_val_if_fail(G_IS_ROBOT(robot), FALSE);
+  g_return_val_if_fail(robot->priv->map != NULL, FALSE);
 
-	x_to = robot->x + dx;
-	y_to = robot->y + dy;
+  if(!g_robot_is_alive(robot))
+    return FALSE;
 
-	robot->energy -= 5;
-	if (robot->energy < 1)
-	{
-		g_signal_emit(robot, g_robot_signals[DEATH], 0);
-	}
+  gboolean retval = FALSE;
 
-	ui_arena_robot_grab(robot->ui, robot->x, robot->y, robot->dir, x_to,
-		y_to, robot->energy, robot->score, robot->shields);
+  gint th;
+  th = what_thing(str);
 
-	/* Did we grab it? */
+  /* determine changes to x,y */
+  gint x_to, y_to, x, y, orientation;
+  map_find_thing(robot->priv->map, robot, &x, &y, &orientation);
 
-	switch (MAP_GET_OBJECT(robot->map, x_to, y_to))
-	{
-	case SPACE:
-	case WALL:
-	case ROBOT:
-		return FALSE;
-		break;
-
-	case BADDIE:
-		robot->shields -= 10;
-		if (robot->shields < 1)
-		{
-			g_signal_emit(robot, g_robot_signals[DEATH], 0);
-		}
-		return (FALSE);
+  map_compute_facing_coords(x, y, orientation, &x_to, &y_to);
 
-	case FOOD:
-		/* I want the net gain to be +10 */
-		robot->energy += 15;
-		break;
+  if (map_get_loc_thing_char(robot->priv->map, x_to, y_to) == th)
+    {
+      retval = TRUE;
+    }
 
-	case PRIZE:
-		robot->score++;
-		break;
-	}
+  /* touching a baddie is hurtful */
+  gint shields_delta = 0;
+  if (map_get_loc_thing_char(robot->priv->map, x_to, y_to) == BADDIE)
+    {
+      shields_delta = -2;
+    }
 
-	/* only successful grabs get here */
-	MAP_SET_OBJECT(robot->map, x_to, y_to, SPACE);
-	ui_arena_add_thing(robot->ui, x_to, y_to, SPACE);
+  g_robot_stats_update(robot, "robot-feel", 4,
+		       ARG_ENERGY, robot->priv->stats.energy - action_energy_cost[ACTION_FEEL],
+		       ARG_SHIELDS, robot->priv->stats.shields + shields_delta);
 
-	return TRUE;
+  return retval;
 }
 
-gboolean g_robot_zap(GRobot *robot)
+gboolean
+g_robot_look(GRobot *robot, gchar *str)
 {
-	gint x_to, y_to;
-	gint dx = 0, dy = 0;
+  g_return_val_if_fail(G_IS_ROBOT(robot), FALSE);
+  g_return_val_if_fail(robot->priv->map != NULL, FALSE);
 
-	g_return_val_if_fail(robot->ui != NULL && robot->map != NULL, FALSE);
+  if(!g_robot_is_alive(robot))
+    return FALSE;
 
-	/* determine changes to x,y */
+  gboolean retval = FALSE;
+  gint th;
 
-	switch (robot->dir)
-	{
-	case NORTH:				/* N */
-		dx = 0;
-		dy = -1;
-		break;
-	case EAST:					/* E */
-		dx = 1;
-		dy = 0;
-		break;
-	case SOUTH:				/* S */
-		dx = 0;
-		dy = 1;
-		break;
-	case WEST:					/* W */
-		dx = -1;
-		dy = 0;
-		break;
-	}
+  th = what_thing(str);
 
-	/* Try to zap the thing */
+  /* determine changes to x,y */
+  gint x_to, y_to, x, y, orientation;
+  map_find_thing(robot->priv->map, robot, &x, &y, &orientation);
 
-	x_to = robot->x + dx;
-	y_to = robot->y + dy;
+  map_compute_facing_coords(x, y, orientation, &x_to, &y_to);
 
-	robot->energy -= 10;
-	if (robot->energy < 1)
-	{
-		g_signal_emit(robot, g_robot_signals[DEATH], 0);
-	}
-	robot->shots++;
-	ui_arena_robot_zap(robot->ui, robot->x, robot->y, robot->dir, x_to,
-		y_to, robot->energy, robot->score, robot->shields);
+  while (map_get_loc_thing_char(robot->priv->map, x_to, y_to) == SPACE)
+    {
+      map_compute_facing_coords(x_to, y_to, orientation, &x_to, &y_to);
+    }
 
-	/* Did we destroy it? */
-	switch (MAP_GET_OBJECT(robot->map, x_to, y_to))
-	{
-	case SPACE:
-	case WALL:
-	case ROBOT:				/* what to w/ robots? */
-		return (FALSE);
-		break;
-
-	case BADDIE:
-	case FOOD:
-	case PRIZE:
-		ui_arena_add_thing(robot->ui, x_to, y_to, SPACE);
-		break;
-	}
+  /* Outside the loop, we have found something */
+  if (map_get_loc_thing_char(robot->priv->map, x_to, y_to) == th)
+    {
+      retval = TRUE;
+    }
 
-	/* only success gets here */
-	MAP_SET_OBJECT(robot->map, x_to, y_to, SPACE);
-	ui_arena_add_thing(robot->ui, x_to, y_to, SPACE);
+  g_robot_stats_update(robot, "robot-look", 2,
+		       ARG_ENERGY, robot->priv->stats.energy - action_energy_cost[ACTION_LOOK]);
 
-	return TRUE;
+  return retval;
 }
 
-gboolean g_robot_stop(GRobot *robot)
+gboolean
+g_robot_grab(GRobot *robot)
 {
-	/* Must be a SCM function, even though it returns no value */
-	/* Stop the robot immediately */
-
-	g_signal_emit(robot, g_robot_signals[DEATH], 0);
+  g_return_val_if_fail(G_IS_ROBOT(robot), FALSE);
+  g_return_val_if_fail(robot->priv->map != NULL, FALSE);
+
+  if(!g_robot_is_alive(robot))
+    return FALSE;
+
+  gboolean retval = FALSE;
+  const gint food_energy_gain = 15;
+  const gint baddie_shield_cost = 10;
+  const gint prize_score_gain = 1;
+
+  /* determine changes to x,y */
+  gint x_to, y_to, x, y, orientation;
+  map_find_thing(robot->priv->map, robot, &x, &y, &orientation);
+
+  map_compute_facing_coords(x, y, orientation, &x_to, &y_to);
+
+  gint energy_delta = - action_energy_cost[ACTION_GRAB];
+  gint shields_delta = 0;
+  gint score_delta = 0;
+
+  switch (map_get_loc_thing_char(robot->priv->map, x_to, y_to))
+    {
+    case SPACE:
+    case WALL:
+    case ROBOT:
+      retval = FALSE;
+      break;
+    case BADDIE:
+      shields_delta = - baddie_shield_cost;
+      retval = FALSE;
+      break;
+    case FOOD:
+      /* I want the net gain to be +10 */
+      energy_delta = energy_delta + food_energy_gain;
+      retval = TRUE;
+      break;
+    case PRIZE:
+      score_delta = score_delta + prize_score_gain;
+      retval = TRUE;
+      break;
+    }
+
+  /* only successful grabs get here */
+  if(retval)
+    map_remove_thing(robot->priv->map, x_to, y_to);
+
+  g_robot_stats_update(robot, "robot-grab", 6,
+		       ARG_ENERGY, robot->priv->stats.energy + energy_delta,
+		       ARG_SHIELDS, robot->priv->stats.shields + shields_delta,
+		       ARG_SCORE, robot->priv->stats.score + score_delta);
+
+  return retval;
+}
 
-	return TRUE;				/* never gets here */
+gboolean
+g_robot_zap(GRobot *robot)
+{
+  g_return_val_if_fail(G_IS_ROBOT(robot), FALSE);
+  g_return_val_if_fail(robot->priv->map != NULL, FALSE);
+
+  if(!g_robot_is_alive(robot))
+    return FALSE;
+
+  gboolean retval = FALSE;
+
+  /* determine changes to x,y */
+  gint x_to, y_to, x, y, orientation;
+  map_find_thing(robot->priv->map, robot, &x, &y, &orientation);
+
+  map_compute_facing_coords(x, y, orientation, &x_to, &y_to);
+
+  /* Did we destroy it? */
+  switch (map_get_loc_thing_char(robot->priv->map, x_to, y_to))
+    {
+    case SPACE:
+    case WALL:
+    case ROBOT:				/* what to w/ robots? */
+      retval = FALSE;
+      break;
+    case BADDIE:
+    case FOOD:
+    case PRIZE:
+      retval = map_remove_thing(robot->priv->map, x_to, y_to);
+      break;
+    }
+
+  g_robot_stats_update(robot, "robot-zap", 4,
+		       ARG_ENERGY, robot->priv->stats.energy - action_energy_cost[ACTION_ZAP],
+		       ARG_SHOTS, robot->priv->stats.shots + 1);
+
+  return retval;
 }
 
-static gint what_thing(const gchar *th)
+gboolean
+g_robot_stop(GRobot *robot)
 {
-	/* what_thing - this function scans the list of possible things
-	   (strings) and returns a cthing.  Returns -1 if not found in the
-	   list. */
+  g_signal_emit(robot, g_robot_signals[DEATH], 0);
 
-	/* My idea here is that by return -1 on error, this won't match
-	   anything in the list of cthings.  That way, the function that
-	   uses what_thing to determine the cthing doesn't have to care if
-	   the call failed or not.  This helps me keep the code simple,
-	   since now I don't have to add a branch for failure, but which
-	   also decrements energy. */
+  return TRUE;
+}
 
+/** Scans the list of possible things (strings) and returns a cthing
+ *   (location character).
+ *
+ * My idea here is that by return -1 on error, this won't match
+ * anything in the list of cthings.  That way, the function that uses
+ * what_thing to determine the cthing doesn't have to care if the call
+ * failed or not.  This helps me keep the code simple, since now I
+ * don't have to add a branch for failure, but which also decrements
+ * energy.
+ *
+ * \param[in] th string representing the location type.
+ * \sa g_robot_feel g_robot_smell g_robot_look
+ *
+ * \returns -1 if not found in the list.
+ */
+static gint
+what_thing(const gchar *th)
+{
 	gint i;
 
 	for (i = 0; i < 6; i++)
